#if !defined(__STREAM_H__)

#define __STREAM_H__

/* kludge, runtime.h does not check for double inclusion */
#if !defined(SP_TYPE_VARIABLE)
#	define PROTO
#	include "/usr/local/lib/sicstus2.1/Runtime/runtime.h"
#endif

typedef struct {
	SP_term SP_streamPtr;
	unsigned size;
	int readIndex;
	int writeIndex;
	char *buffer;
	} ComsStream;

int Stream_open FN_PROTOTYPE((ComsStream *stream));
int Stream_close FN_PROTOTYPE((ComsStream *stream));
int Stream_link FN_PROTOTYPE((ComsStream *stream, FILE *file));

int Stream_getc FN_PROTOTYPE((ComsStream *handle));
int Stream_putc FN_PROTOTYPE((int c, ComsStream  *handle));
int Stream_flush FN_PROTOTYPE((ComsStream *handle));
int Stream_eof FN_PROTOTYPE((ComsStream *handle));

char *Stream_gets FN_PROTOTYPE((char *string, int n, ComsStream *stream));
int Stream_puts FN_PROTOTYPE((char *string, ComsStream *stream));

#endif /* __STREAM_H__ */
